---
author: Nihilist
date: 2025-05-20
gitea_url: "http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/260"
xmr: 8AUYjhQeG3D5aodJDtqG499N5jXXM71gYKD8LgSsFB9BUV1o7muLv3DXHoydRTK4SZaaUBq4EAUqpZHLrX2VZLH71Jrd9k8
---
# Roadmap Progress (as of May 2025)

Welcome to our new monthly activity recap of the Nihilism OPSEC Roadmap. The opsec blog covers a wide array of topics and tutorials, but all share the same goal: **empowering the individual, to tell them how to make themselves ungovernable.** Privacy comes first, then anonymity, and lastly deniability.

Beyond our Privacy/Anonymity/Deniability classification we have 3 types of tutorials:

- **Clientside Tutorials:** Achieving your opsec goals on your own computer/mobile
- **Serverside (Self-Hosting) Tutorials:** Achieving opsec goals on your home server
- **Serverside (Remote) Tutorials:** Achieving opsec on remote servers (VPSes / Dedicated servers)

Within this classification of tutorials we have a special category of tutorials called the "Core tutorials" which are basically the tutorials that enable everything that is opsec-related that we are talking about. **You can consider those to be the actual backbone of your operational security**.

Our roadmap is based on those critical tutorials first and foremost, as they are actually making every other tutorial we have possible.

![](blog_roadmap.drawio.png)

## Clientside tutorials (85% completed)

This is where the opsec blog shines currently, thanks to the work that has been done so far, we covered nearly everything that one can accomplish from his own computer, for his or her own opsec.

Currently this section is only missing the following tutorials:

- **SimpleX Deniable Chats** [#317](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/317)
- **USB-triggered emergency shutdowns** [#316](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/316)

We are also missing some improvements for the following tutorials:

- **Monero Inheritence** [#48](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/48) : need to get rid of the email server requirement
- **Haveno Fiat -> XMR trades** [#53](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/53) : need to update how to use haveno on whonix

## Serverside Self-Hosting tutorials (20% completed)

This is the part where the opsec blog needs the most work, self-hosting as an operational security concept has been left largely unexplored, and that's where we currently are lacking the most. 

Currently this section is missing the following tutorials:

- **Self-Hosting a server : kicksecure host OS recap + RDP + SSH access** [#318](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/318)
- **Self-hosting a Hypervisor (QEMU/KVM + Cockpit + Private VM setup)** [#319](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/319)
- **using a VPS to route the traffic to a self-hosted service (hiding your home public IP from the users)** [#320](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/320)
- **Making your Homeserver reachable via a hidden service (SSH + RDP + Cockpit)** [#323](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/323)
- **Why should I use Whonix for Hidden services ?** [#324](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/324)
- **Serverside Sensitive VM setup (whonix in a VC hidden volume)** [#327](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/327)
- **Host-OS WAN internet connection failover** [#185](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/185)
- **Automating Emergency Shutdowns (webcam movement detection)** [#328](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/328)
- **Automating Emergency Shutdowns (detecting usb changes)** [#329](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/329)



We are also missing some improvements for the following tutorials:

- **Anonymous Simplex SMP & XFTP Servers setup** [#325](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/325) : serverside part needs to be moved from the clientside to this section


## Serverside (Remote) Tutorials (50% completed)

For now on the remote serverside tutorials we are halfway there, we are lacking the following tutorials as of right now:

- **Backing up data on VPSes without revealing the content to the cloud provider** [#321](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/321)
- **Anonymous Alerting System (via SimpleX bots)** [#223](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/223)
- **Deniably renting servers from the Sensitive VM** [#326](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/326)
- **Sensitive remote servers organization** [#222](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/222)


And we are missing some improvements to those tutorials aswell:

- **E2EE: why can't i trust serverside encryption ?** [#84](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/84)
- **Private Simplex Servers setup** [#322](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/issues/322)


