# Operational Security: Privacy, Anonymity and Deniability

**BREAKING NEWS:** Welcome to the Nihilism Opsec Blog v2.0! We are now running mkdocs-material and all of our blogposts have been converted to Markdown to make it simplify the contribution process in the long run.

![](opsec4levels/0.png)

[SHOWCASED TUTORIAL:](opsec4levels/index.md) Learn how to audit your own setup, to determine your Operational Security (OPSEC) Level, and find out what is the most appropriate internet use for it.

With this new mkdocs blog version, we have completely changed how you can find blogposts that are relevant to your own situation. Thanks to the Mkdocs search plugin, **you can now search for specific terms (ex:Tor, Monero, Anonymity, Deniability) in the search bar at the top** to find the blogposts that are relevant to what you wish to know. Don't hesitate to combine search terms together to try and find what you need. 

## What is the goal of the Opsec blog ?

**In short, we're here to tell you why and how you can become ungovernable.**

- Priority number 1: Solving the lack of education
- Priority number 2: Advice applicable to 90% of the people out there, to defeat 99% of the risks
- Priority number 3: Simplifying the advice as much as possible

(Check out [this blogpost](whytheblog/index.md) for more details on our mission)

## Our latest contributed tutorials:
- 2025-05-22:  [File Verifications (Shasums and PGP)](file-verification/index.md)
- 2025-05-21:  [Realistic OPSEC Mistakes and Threat Scenarios](opsecmistakes/index.md)
- 2025-05-16: [The State is the Enemy](stateistheenemy/index.md)
- 2025-05-16: [Why can't I use signal to chat anonymously?](signalnoanonymity/index.md)
- 2025-05-02: [Convert Monero into other Cryptos Anonymously (XMR -> LTC)](haveno-crypto/index.md)
- 2025-05-01: [How to get your first Monero ? (xmrbazaar.com, crypto swaps, p2p chats, or work)](monerofirst/index.md)
- 2025-05-01: [Why should I self-host my own services ?](selfhosting/index.md)
- 2025-05-01: [Our stance on sensitive activities](stancesensitive/index.md)
- 2025-04-30: [What is the goal of the Opsec blog?](whytheblog/index.md)
- 2025-04-27: [Anonymous Monitoring (Grafana, Prometheus, Node-exporter)](anonymous_server_monitoring/index.md)
- 2025-04-21: [Self-Hosted LLM Hidden Service](openwebuilocalllms/index.md)
- 2025-04-20: [Where to Hide your Monero Wealth?](monerowealth/index.md)
## Our upcoming tutorials:

To know what's in store for the future of the Nihilism Opsec blog, you can check out our [Forgejo opsec project board](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions/projects/1)

If there is a new tutorial that should be added in the opsec blog, let us know in our [SimpleX Chatrooms](http://nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/simplex.html) or as a new git issue our [Forgejo repository](http://git.nowherejezfoltodf4jiyl6r56jnzintap5vyjlia7fkirfsnfizflqd.onion/nihilist/blog-contributions) directly.

## The Blog is open to contributions:

If you want to earn some Monero, you can write new blogposts for us (from 10 to 50 euros worth of monero per tutorial, as [advertised on xmrbazaar](https://xmrbazaar.com/listing/UsWA/)), if you're interested, check out our [how to contribute guide](contribute/index.md), and make sure that you follow our [quality standard](qualitystandard/index.md). 


## Inspirations 

- [The Hitchhiker's guide to Anonymity](https://anonymousplanet.org/guide/)
- [Hackliberty Resources](https://git.hackliberty.org/hackliberty.org/Hack-Liberty-Resources)
- [Dread /d/opsec](http://dreadytofatroptsdj6io7l3xptbet6onoyno2yv7jicoxknyazubrad.onion/d/opsec)
- [Sam bent's youtube channel](https://www.youtube.com/@Sam_Bent)
- [Monero Talk's youtube channel](https://www.youtube.com/@MoneroTalk)

